// Generated by the protocol buffer compiler.  DO NOT EDIT!
// NO CHECKED-IN PROTOBUF GENCODE
// source: src/main/protobuf/action_cache.proto
// Protobuf Java Version: 4.29.0

package com.google.devtools.build.lib.actions.cache;

public final class Protos {
  private Protos() {}
  static {
    com.google.protobuf.RuntimeVersion.validateProtobufGencodeVersion(
      com.google.protobuf.RuntimeVersion.RuntimeDomain.PUBLIC,
      /* major= */ 4,
      /* minor= */ 29,
      /* patch= */ 0,
      /* suffix= */ "",
      Protos.class.getName());
  }
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistryLite registry) {
  }

  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
    registerAllExtensions(
        (com.google.protobuf.ExtensionRegistryLite) registry);
  }
  public interface ActionCacheStatisticsOrBuilder extends
      // @@protoc_insertion_point(interface_extends:blaze.ActionCacheStatistics)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * Size of the action cache in bytes.
     *
     * This is computed by the code that persists the action cache to disk and
     * represents the size of the written files, which has no direct relation to
     * the number of entries in the cache.
     * </pre>
     *
     * <code>uint64 size_in_bytes = 1;</code>
     * @return The sizeInBytes.
     */
    long getSizeInBytes();

    /**
     * <pre>
     * Time it took to save the action cache to disk.
     * </pre>
     *
     * <code>uint64 save_time_in_ms = 2;</code>
     * @return The saveTimeInMs.
     */
    long getSaveTimeInMs();

    /**
     * <pre>
     * Cache counters.
     * </pre>
     *
     * <code>int32 hits = 3;</code>
     * @return The hits.
     */
    int getHits();

    /**
     * <code>int32 misses = 4;</code>
     * @return The misses.
     */
    int getMisses();

    /**
     * <pre>
     * Breakdown of the cache misses based on the reasons behind them.
     * </pre>
     *
     * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
     */
    java.util.List<com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail> 
        getMissDetailsList();
    /**
     * <pre>
     * Breakdown of the cache misses based on the reasons behind them.
     * </pre>
     *
     * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
     */
    com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail getMissDetails(int index);
    /**
     * <pre>
     * Breakdown of the cache misses based on the reasons behind them.
     * </pre>
     *
     * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
     */
    int getMissDetailsCount();
    /**
     * <pre>
     * Breakdown of the cache misses based on the reasons behind them.
     * </pre>
     *
     * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
     */
    java.util.List<? extends com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetailOrBuilder> 
        getMissDetailsOrBuilderList();
    /**
     * <pre>
     * Breakdown of the cache misses based on the reasons behind them.
     * </pre>
     *
     * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
     */
    com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetailOrBuilder getMissDetailsOrBuilder(
        int index);

    /**
     * <pre>
     * Time it took to load the action cache from disk. Reported as 0 if the
     * action cache has not been loaded in this invocation.
     * </pre>
     *
     * <code>uint64 load_time_in_ms = 6;</code>
     * @return The loadTimeInMs.
     */
    long getLoadTimeInMs();
  }
  /**
   * <pre>
   * Information about the action cache behavior during a single build.
   * </pre>
   *
   * Protobuf type {@code blaze.ActionCacheStatistics}
   */
  public static final class ActionCacheStatistics extends
      com.google.protobuf.GeneratedMessage implements
      // @@protoc_insertion_point(message_implements:blaze.ActionCacheStatistics)
      ActionCacheStatisticsOrBuilder {
  private static final long serialVersionUID = 0L;
    static {
      com.google.protobuf.RuntimeVersion.validateProtobufGencodeVersion(
        com.google.protobuf.RuntimeVersion.RuntimeDomain.PUBLIC,
        /* major= */ 4,
        /* minor= */ 29,
        /* patch= */ 0,
        /* suffix= */ "",
        ActionCacheStatistics.class.getName());
    }
    // Use ActionCacheStatistics.newBuilder() to construct.
    private ActionCacheStatistics(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
      super(builder);
    }
    private ActionCacheStatistics() {
      missDetails_ = java.util.Collections.emptyList();
    }

    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.actions.cache.Protos.internal_static_blaze_ActionCacheStatistics_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.actions.cache.Protos.internal_static_blaze_ActionCacheStatistics_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.class, com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.Builder.class);
    }

    /**
     * <pre>
     * Reasons for not finding an action in the cache.
     * </pre>
     *
     * Protobuf enum {@code blaze.ActionCacheStatistics.MissReason}
     */
    public enum MissReason
        implements com.google.protobuf.ProtocolMessageEnum {
      /**
       * <pre>
       * currently not used
       * </pre>
       *
       * <code>DIFFERENT_ACTION_KEY = 0;</code>
       */
      DIFFERENT_ACTION_KEY(0),
      /**
       * <pre>
       * currently not used
       * </pre>
       *
       * <code>DIFFERENT_DEPS = 1;</code>
       */
      DIFFERENT_DEPS(1),
      /**
       * <pre>
       * currently not used
       * </pre>
       *
       * <code>DIFFERENT_ENVIRONMENT = 2;</code>
       */
      DIFFERENT_ENVIRONMENT(2),
      /**
       * <pre>
       * currently not used
       * </pre>
       *
       * <code>DIFFERENT_FILES = 3;</code>
       */
      DIFFERENT_FILES(3),
      /**
       * <pre>
       * A cache entry was found, but it was corrupted and we ignored it.
       * </pre>
       *
       * <code>CORRUPTED_CACHE_ENTRY = 4;</code>
       */
      CORRUPTED_CACHE_ENTRY(4),
      /**
       * <pre>
       * No cache entry was found.
       * </pre>
       *
       * <code>NOT_CACHED = 5;</code>
       */
      NOT_CACHED(5),
      /**
       * <pre>
       * Unconditional execution was requested.
       * </pre>
       *
       * <code>UNCONDITIONAL_EXECUTION = 6;</code>
       */
      UNCONDITIONAL_EXECUTION(6),
      /**
       * <pre>
       * A cache entry was found, but it contained a different digest.
       * This could be due to a change in the command line, input or output file
       * paths or contents, environment variables, or certain build flags.
       * </pre>
       *
       * <code>DIGEST_MISMATCH = 7;</code>
       */
      DIGEST_MISMATCH(7),
      UNRECOGNIZED(-1),
      ;

      static {
        com.google.protobuf.RuntimeVersion.validateProtobufGencodeVersion(
          com.google.protobuf.RuntimeVersion.RuntimeDomain.PUBLIC,
          /* major= */ 4,
          /* minor= */ 29,
          /* patch= */ 0,
          /* suffix= */ "",
          MissReason.class.getName());
      }
      /**
       * <pre>
       * currently not used
       * </pre>
       *
       * <code>DIFFERENT_ACTION_KEY = 0;</code>
       */
      public static final int DIFFERENT_ACTION_KEY_VALUE = 0;
      /**
       * <pre>
       * currently not used
       * </pre>
       *
       * <code>DIFFERENT_DEPS = 1;</code>
       */
      public static final int DIFFERENT_DEPS_VALUE = 1;
      /**
       * <pre>
       * currently not used
       * </pre>
       *
       * <code>DIFFERENT_ENVIRONMENT = 2;</code>
       */
      public static final int DIFFERENT_ENVIRONMENT_VALUE = 2;
      /**
       * <pre>
       * currently not used
       * </pre>
       *
       * <code>DIFFERENT_FILES = 3;</code>
       */
      public static final int DIFFERENT_FILES_VALUE = 3;
      /**
       * <pre>
       * A cache entry was found, but it was corrupted and we ignored it.
       * </pre>
       *
       * <code>CORRUPTED_CACHE_ENTRY = 4;</code>
       */
      public static final int CORRUPTED_CACHE_ENTRY_VALUE = 4;
      /**
       * <pre>
       * No cache entry was found.
       * </pre>
       *
       * <code>NOT_CACHED = 5;</code>
       */
      public static final int NOT_CACHED_VALUE = 5;
      /**
       * <pre>
       * Unconditional execution was requested.
       * </pre>
       *
       * <code>UNCONDITIONAL_EXECUTION = 6;</code>
       */
      public static final int UNCONDITIONAL_EXECUTION_VALUE = 6;
      /**
       * <pre>
       * A cache entry was found, but it contained a different digest.
       * This could be due to a change in the command line, input or output file
       * paths or contents, environment variables, or certain build flags.
       * </pre>
       *
       * <code>DIGEST_MISMATCH = 7;</code>
       */
      public static final int DIGEST_MISMATCH_VALUE = 7;


      public final int getNumber() {
        if (this == UNRECOGNIZED) {
          throw new java.lang.IllegalArgumentException(
              "Can't get the number of an unknown enum value.");
        }
        return value;
      }

      /**
       * @param value The numeric wire value of the corresponding enum entry.
       * @return The enum associated with the given numeric wire value.
       * @deprecated Use {@link #forNumber(int)} instead.
       */
      @java.lang.Deprecated
      public static MissReason valueOf(int value) {
        return forNumber(value);
      }

      /**
       * @param value The numeric wire value of the corresponding enum entry.
       * @return The enum associated with the given numeric wire value.
       */
      public static MissReason forNumber(int value) {
        switch (value) {
          case 0: return DIFFERENT_ACTION_KEY;
          case 1: return DIFFERENT_DEPS;
          case 2: return DIFFERENT_ENVIRONMENT;
          case 3: return DIFFERENT_FILES;
          case 4: return CORRUPTED_CACHE_ENTRY;
          case 5: return NOT_CACHED;
          case 6: return UNCONDITIONAL_EXECUTION;
          case 7: return DIGEST_MISMATCH;
          default: return null;
        }
      }

      public static com.google.protobuf.Internal.EnumLiteMap<MissReason>
          internalGetValueMap() {
        return internalValueMap;
      }
      private static final com.google.protobuf.Internal.EnumLiteMap<
          MissReason> internalValueMap =
            new com.google.protobuf.Internal.EnumLiteMap<MissReason>() {
              public MissReason findValueByNumber(int number) {
                return MissReason.forNumber(number);
              }
            };

      public final com.google.protobuf.Descriptors.EnumValueDescriptor
          getValueDescriptor() {
        if (this == UNRECOGNIZED) {
          throw new java.lang.IllegalStateException(
              "Can't get the descriptor of an unrecognized enum value.");
        }
        return getDescriptor().getValues().get(ordinal());
      }
      public final com.google.protobuf.Descriptors.EnumDescriptor
          getDescriptorForType() {
        return getDescriptor();
      }
      public static final com.google.protobuf.Descriptors.EnumDescriptor
          getDescriptor() {
        return com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.getDescriptor().getEnumTypes().get(0);
      }

      private static final MissReason[] VALUES = values();

      public static MissReason valueOf(
          com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
        if (desc.getType() != getDescriptor()) {
          throw new java.lang.IllegalArgumentException(
            "EnumValueDescriptor is not for this type.");
        }
        if (desc.getIndex() == -1) {
          return UNRECOGNIZED;
        }
        return VALUES[desc.getIndex()];
      }

      private final int value;

      private MissReason(int value) {
        this.value = value;
      }

      // @@protoc_insertion_point(enum_scope:blaze.ActionCacheStatistics.MissReason)
    }

    public interface MissDetailOrBuilder extends
        // @@protoc_insertion_point(interface_extends:blaze.ActionCacheStatistics.MissDetail)
        com.google.protobuf.MessageOrBuilder {

      /**
       * <code>.blaze.ActionCacheStatistics.MissReason reason = 1;</code>
       * @return The enum numeric value on the wire for reason.
       */
      int getReasonValue();
      /**
       * <code>.blaze.ActionCacheStatistics.MissReason reason = 1;</code>
       * @return The reason.
       */
      com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissReason getReason();

      /**
       * <code>int32 count = 2;</code>
       * @return The count.
       */
      int getCount();
    }
    /**
     * <pre>
     * Detailed information for a particular miss reason.
     * </pre>
     *
     * Protobuf type {@code blaze.ActionCacheStatistics.MissDetail}
     */
    public static final class MissDetail extends
        com.google.protobuf.GeneratedMessage implements
        // @@protoc_insertion_point(message_implements:blaze.ActionCacheStatistics.MissDetail)
        MissDetailOrBuilder {
    private static final long serialVersionUID = 0L;
      static {
        com.google.protobuf.RuntimeVersion.validateProtobufGencodeVersion(
          com.google.protobuf.RuntimeVersion.RuntimeDomain.PUBLIC,
          /* major= */ 4,
          /* minor= */ 29,
          /* patch= */ 0,
          /* suffix= */ "",
          MissDetail.class.getName());
      }
      // Use MissDetail.newBuilder() to construct.
      private MissDetail(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
        super(builder);
      }
      private MissDetail() {
        reason_ = 0;
      }

      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.actions.cache.Protos.internal_static_blaze_ActionCacheStatistics_MissDetail_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.actions.cache.Protos.internal_static_blaze_ActionCacheStatistics_MissDetail_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail.class, com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail.Builder.class);
      }

      public static final int REASON_FIELD_NUMBER = 1;
      private int reason_ = 0;
      /**
       * <code>.blaze.ActionCacheStatistics.MissReason reason = 1;</code>
       * @return The enum numeric value on the wire for reason.
       */
      @java.lang.Override public int getReasonValue() {
        return reason_;
      }
      /**
       * <code>.blaze.ActionCacheStatistics.MissReason reason = 1;</code>
       * @return The reason.
       */
      @java.lang.Override public com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissReason getReason() {
        com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissReason result = com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissReason.forNumber(reason_);
        return result == null ? com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissReason.UNRECOGNIZED : result;
      }

      public static final int COUNT_FIELD_NUMBER = 2;
      private int count_ = 0;
      /**
       * <code>int32 count = 2;</code>
       * @return The count.
       */
      @java.lang.Override
      public int getCount() {
        return count_;
      }

      private byte memoizedIsInitialized = -1;
      @java.lang.Override
      public final boolean isInitialized() {
        byte isInitialized = memoizedIsInitialized;
        if (isInitialized == 1) return true;
        if (isInitialized == 0) return false;

        memoizedIsInitialized = 1;
        return true;
      }

      @java.lang.Override
      public void writeTo(com.google.protobuf.CodedOutputStream output)
                          throws java.io.IOException {
        if (reason_ != com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissReason.DIFFERENT_ACTION_KEY.getNumber()) {
          output.writeEnum(1, reason_);
        }
        if (count_ != 0) {
          output.writeInt32(2, count_);
        }
        getUnknownFields().writeTo(output);
      }

      @java.lang.Override
      public int getSerializedSize() {
        int size = memoizedSize;
        if (size != -1) return size;

        size = 0;
        if (reason_ != com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissReason.DIFFERENT_ACTION_KEY.getNumber()) {
          size += com.google.protobuf.CodedOutputStream
            .computeEnumSize(1, reason_);
        }
        if (count_ != 0) {
          size += com.google.protobuf.CodedOutputStream
            .computeInt32Size(2, count_);
        }
        size += getUnknownFields().getSerializedSize();
        memoizedSize = size;
        return size;
      }

      @java.lang.Override
      public boolean equals(final java.lang.Object obj) {
        if (obj == this) {
         return true;
        }
        if (!(obj instanceof com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail)) {
          return super.equals(obj);
        }
        com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail other = (com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail) obj;

        if (reason_ != other.reason_) return false;
        if (getCount()
            != other.getCount()) return false;
        if (!getUnknownFields().equals(other.getUnknownFields())) return false;
        return true;
      }

      @java.lang.Override
      public int hashCode() {
        if (memoizedHashCode != 0) {
          return memoizedHashCode;
        }
        int hash = 41;
        hash = (19 * hash) + getDescriptor().hashCode();
        hash = (37 * hash) + REASON_FIELD_NUMBER;
        hash = (53 * hash) + reason_;
        hash = (37 * hash) + COUNT_FIELD_NUMBER;
        hash = (53 * hash) + getCount();
        hash = (29 * hash) + getUnknownFields().hashCode();
        memoizedHashCode = hash;
        return hash;
      }

      public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail parseFrom(
          java.nio.ByteBuffer data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data);
      }
      public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail parseFrom(
          java.nio.ByteBuffer data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data, extensionRegistry);
      }
      public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail parseFrom(
          com.google.protobuf.ByteString data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data);
      }
      public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail parseFrom(
          com.google.protobuf.ByteString data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data, extensionRegistry);
      }
      public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail parseFrom(byte[] data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data);
      }
      public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail parseFrom(
          byte[] data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data, extensionRegistry);
      }
      public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail parseFrom(java.io.InputStream input)
          throws java.io.IOException {
        return com.google.protobuf.GeneratedMessage
            .parseWithIOException(PARSER, input);
      }
      public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail parseFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return com.google.protobuf.GeneratedMessage
            .parseWithIOException(PARSER, input, extensionRegistry);
      }

      public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail parseDelimitedFrom(java.io.InputStream input)
          throws java.io.IOException {
        return com.google.protobuf.GeneratedMessage
            .parseDelimitedWithIOException(PARSER, input);
      }

      public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail parseDelimitedFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return com.google.protobuf.GeneratedMessage
            .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
      }
      public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail parseFrom(
          com.google.protobuf.CodedInputStream input)
          throws java.io.IOException {
        return com.google.protobuf.GeneratedMessage
            .parseWithIOException(PARSER, input);
      }
      public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail parseFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return com.google.protobuf.GeneratedMessage
            .parseWithIOException(PARSER, input, extensionRegistry);
      }

      @java.lang.Override
      public Builder newBuilderForType() { return newBuilder(); }
      public static Builder newBuilder() {
        return DEFAULT_INSTANCE.toBuilder();
      }
      public static Builder newBuilder(com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail prototype) {
        return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
      }
      @java.lang.Override
      public Builder toBuilder() {
        return this == DEFAULT_INSTANCE
            ? new Builder() : new Builder().mergeFrom(this);
      }

      @java.lang.Override
      protected Builder newBuilderForType(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        Builder builder = new Builder(parent);
        return builder;
      }
      /**
       * <pre>
       * Detailed information for a particular miss reason.
       * </pre>
       *
       * Protobuf type {@code blaze.ActionCacheStatistics.MissDetail}
       */
      public static final class Builder extends
          com.google.protobuf.GeneratedMessage.Builder<Builder> implements
          // @@protoc_insertion_point(builder_implements:blaze.ActionCacheStatistics.MissDetail)
          com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetailOrBuilder {
        public static final com.google.protobuf.Descriptors.Descriptor
            getDescriptor() {
          return com.google.devtools.build.lib.actions.cache.Protos.internal_static_blaze_ActionCacheStatistics_MissDetail_descriptor;
        }

        @java.lang.Override
        protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
            internalGetFieldAccessorTable() {
          return com.google.devtools.build.lib.actions.cache.Protos.internal_static_blaze_ActionCacheStatistics_MissDetail_fieldAccessorTable
              .ensureFieldAccessorsInitialized(
                  com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail.class, com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail.Builder.class);
        }

        // Construct using com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail.newBuilder()
        private Builder() {

        }

        private Builder(
            com.google.protobuf.GeneratedMessage.BuilderParent parent) {
          super(parent);

        }
        @java.lang.Override
        public Builder clear() {
          super.clear();
          bitField0_ = 0;
          reason_ = 0;
          count_ = 0;
          return this;
        }

        @java.lang.Override
        public com.google.protobuf.Descriptors.Descriptor
            getDescriptorForType() {
          return com.google.devtools.build.lib.actions.cache.Protos.internal_static_blaze_ActionCacheStatistics_MissDetail_descriptor;
        }

        @java.lang.Override
        public com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail getDefaultInstanceForType() {
          return com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail.getDefaultInstance();
        }

        @java.lang.Override
        public com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail build() {
          com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail result = buildPartial();
          if (!result.isInitialized()) {
            throw newUninitializedMessageException(result);
          }
          return result;
        }

        @java.lang.Override
        public com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail buildPartial() {
          com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail result = new com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail(this);
          if (bitField0_ != 0) { buildPartial0(result); }
          onBuilt();
          return result;
        }

        private void buildPartial0(com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail result) {
          int from_bitField0_ = bitField0_;
          if (((from_bitField0_ & 0x00000001) != 0)) {
            result.reason_ = reason_;
          }
          if (((from_bitField0_ & 0x00000002) != 0)) {
            result.count_ = count_;
          }
        }

        @java.lang.Override
        public Builder mergeFrom(com.google.protobuf.Message other) {
          if (other instanceof com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail) {
            return mergeFrom((com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail)other);
          } else {
            super.mergeFrom(other);
            return this;
          }
        }

        public Builder mergeFrom(com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail other) {
          if (other == com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail.getDefaultInstance()) return this;
          if (other.reason_ != 0) {
            setReasonValue(other.getReasonValue());
          }
          if (other.getCount() != 0) {
            setCount(other.getCount());
          }
          this.mergeUnknownFields(other.getUnknownFields());
          onChanged();
          return this;
        }

        @java.lang.Override
        public final boolean isInitialized() {
          return true;
        }

        @java.lang.Override
        public Builder mergeFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          if (extensionRegistry == null) {
            throw new java.lang.NullPointerException();
          }
          try {
            boolean done = false;
            while (!done) {
              int tag = input.readTag();
              switch (tag) {
                case 0:
                  done = true;
                  break;
                case 8: {
                  reason_ = input.readEnum();
                  bitField0_ |= 0x00000001;
                  break;
                } // case 8
                case 16: {
                  count_ = input.readInt32();
                  bitField0_ |= 0x00000002;
                  break;
                } // case 16
                default: {
                  if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                    done = true; // was an endgroup tag
                  }
                  break;
                } // default:
              } // switch (tag)
            } // while (!done)
          } catch (com.google.protobuf.InvalidProtocolBufferException e) {
            throw e.unwrapIOException();
          } finally {
            onChanged();
          } // finally
          return this;
        }
        private int bitField0_;

        private int reason_ = 0;
        /**
         * <code>.blaze.ActionCacheStatistics.MissReason reason = 1;</code>
         * @return The enum numeric value on the wire for reason.
         */
        @java.lang.Override public int getReasonValue() {
          return reason_;
        }
        /**
         * <code>.blaze.ActionCacheStatistics.MissReason reason = 1;</code>
         * @param value The enum numeric value on the wire for reason to set.
         * @return This builder for chaining.
         */
        public Builder setReasonValue(int value) {
          reason_ = value;
          bitField0_ |= 0x00000001;
          onChanged();
          return this;
        }
        /**
         * <code>.blaze.ActionCacheStatistics.MissReason reason = 1;</code>
         * @return The reason.
         */
        @java.lang.Override
        public com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissReason getReason() {
          com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissReason result = com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissReason.forNumber(reason_);
          return result == null ? com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissReason.UNRECOGNIZED : result;
        }
        /**
         * <code>.blaze.ActionCacheStatistics.MissReason reason = 1;</code>
         * @param value The reason to set.
         * @return This builder for chaining.
         */
        public Builder setReason(com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissReason value) {
          if (value == null) {
            throw new NullPointerException();
          }
          bitField0_ |= 0x00000001;
          reason_ = value.getNumber();
          onChanged();
          return this;
        }
        /**
         * <code>.blaze.ActionCacheStatistics.MissReason reason = 1;</code>
         * @return This builder for chaining.
         */
        public Builder clearReason() {
          bitField0_ = (bitField0_ & ~0x00000001);
          reason_ = 0;
          onChanged();
          return this;
        }

        private int count_ ;
        /**
         * <code>int32 count = 2;</code>
         * @return The count.
         */
        @java.lang.Override
        public int getCount() {
          return count_;
        }
        /**
         * <code>int32 count = 2;</code>
         * @param value The count to set.
         * @return This builder for chaining.
         */
        public Builder setCount(int value) {

          count_ = value;
          bitField0_ |= 0x00000002;
          onChanged();
          return this;
        }
        /**
         * <code>int32 count = 2;</code>
         * @return This builder for chaining.
         */
        public Builder clearCount() {
          bitField0_ = (bitField0_ & ~0x00000002);
          count_ = 0;
          onChanged();
          return this;
        }

        // @@protoc_insertion_point(builder_scope:blaze.ActionCacheStatistics.MissDetail)
      }

      // @@protoc_insertion_point(class_scope:blaze.ActionCacheStatistics.MissDetail)
      private static final com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail DEFAULT_INSTANCE;
      static {
        DEFAULT_INSTANCE = new com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail();
      }

      public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail getDefaultInstance() {
        return DEFAULT_INSTANCE;
      }

      private static final com.google.protobuf.Parser<MissDetail>
          PARSER = new com.google.protobuf.AbstractParser<MissDetail>() {
        @java.lang.Override
        public MissDetail parsePartialFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          Builder builder = newBuilder();
          try {
            builder.mergeFrom(input, extensionRegistry);
          } catch (com.google.protobuf.InvalidProtocolBufferException e) {
            throw e.setUnfinishedMessage(builder.buildPartial());
          } catch (com.google.protobuf.UninitializedMessageException e) {
            throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
          } catch (java.io.IOException e) {
            throw new com.google.protobuf.InvalidProtocolBufferException(e)
                .setUnfinishedMessage(builder.buildPartial());
          }
          return builder.buildPartial();
        }
      };

      public static com.google.protobuf.Parser<MissDetail> parser() {
        return PARSER;
      }

      @java.lang.Override
      public com.google.protobuf.Parser<MissDetail> getParserForType() {
        return PARSER;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail getDefaultInstanceForType() {
        return DEFAULT_INSTANCE;
      }

    }

    public static final int SIZE_IN_BYTES_FIELD_NUMBER = 1;
    private long sizeInBytes_ = 0L;
    /**
     * <pre>
     * Size of the action cache in bytes.
     *
     * This is computed by the code that persists the action cache to disk and
     * represents the size of the written files, which has no direct relation to
     * the number of entries in the cache.
     * </pre>
     *
     * <code>uint64 size_in_bytes = 1;</code>
     * @return The sizeInBytes.
     */
    @java.lang.Override
    public long getSizeInBytes() {
      return sizeInBytes_;
    }

    public static final int SAVE_TIME_IN_MS_FIELD_NUMBER = 2;
    private long saveTimeInMs_ = 0L;
    /**
     * <pre>
     * Time it took to save the action cache to disk.
     * </pre>
     *
     * <code>uint64 save_time_in_ms = 2;</code>
     * @return The saveTimeInMs.
     */
    @java.lang.Override
    public long getSaveTimeInMs() {
      return saveTimeInMs_;
    }

    public static final int HITS_FIELD_NUMBER = 3;
    private int hits_ = 0;
    /**
     * <pre>
     * Cache counters.
     * </pre>
     *
     * <code>int32 hits = 3;</code>
     * @return The hits.
     */
    @java.lang.Override
    public int getHits() {
      return hits_;
    }

    public static final int MISSES_FIELD_NUMBER = 4;
    private int misses_ = 0;
    /**
     * <code>int32 misses = 4;</code>
     * @return The misses.
     */
    @java.lang.Override
    public int getMisses() {
      return misses_;
    }

    public static final int MISS_DETAILS_FIELD_NUMBER = 5;
    @SuppressWarnings("serial")
    private java.util.List<com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail> missDetails_;
    /**
     * <pre>
     * Breakdown of the cache misses based on the reasons behind them.
     * </pre>
     *
     * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
     */
    @java.lang.Override
    public java.util.List<com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail> getMissDetailsList() {
      return missDetails_;
    }
    /**
     * <pre>
     * Breakdown of the cache misses based on the reasons behind them.
     * </pre>
     *
     * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
     */
    @java.lang.Override
    public java.util.List<? extends com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetailOrBuilder> 
        getMissDetailsOrBuilderList() {
      return missDetails_;
    }
    /**
     * <pre>
     * Breakdown of the cache misses based on the reasons behind them.
     * </pre>
     *
     * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
     */
    @java.lang.Override
    public int getMissDetailsCount() {
      return missDetails_.size();
    }
    /**
     * <pre>
     * Breakdown of the cache misses based on the reasons behind them.
     * </pre>
     *
     * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail getMissDetails(int index) {
      return missDetails_.get(index);
    }
    /**
     * <pre>
     * Breakdown of the cache misses based on the reasons behind them.
     * </pre>
     *
     * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetailOrBuilder getMissDetailsOrBuilder(
        int index) {
      return missDetails_.get(index);
    }

    public static final int LOAD_TIME_IN_MS_FIELD_NUMBER = 6;
    private long loadTimeInMs_ = 0L;
    /**
     * <pre>
     * Time it took to load the action cache from disk. Reported as 0 if the
     * action cache has not been loaded in this invocation.
     * </pre>
     *
     * <code>uint64 load_time_in_ms = 6;</code>
     * @return The loadTimeInMs.
     */
    @java.lang.Override
    public long getLoadTimeInMs() {
      return loadTimeInMs_;
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (sizeInBytes_ != 0L) {
        output.writeUInt64(1, sizeInBytes_);
      }
      if (saveTimeInMs_ != 0L) {
        output.writeUInt64(2, saveTimeInMs_);
      }
      if (hits_ != 0) {
        output.writeInt32(3, hits_);
      }
      if (misses_ != 0) {
        output.writeInt32(4, misses_);
      }
      for (int i = 0; i < missDetails_.size(); i++) {
        output.writeMessage(5, missDetails_.get(i));
      }
      if (loadTimeInMs_ != 0L) {
        output.writeUInt64(6, loadTimeInMs_);
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (sizeInBytes_ != 0L) {
        size += com.google.protobuf.CodedOutputStream
          .computeUInt64Size(1, sizeInBytes_);
      }
      if (saveTimeInMs_ != 0L) {
        size += com.google.protobuf.CodedOutputStream
          .computeUInt64Size(2, saveTimeInMs_);
      }
      if (hits_ != 0) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(3, hits_);
      }
      if (misses_ != 0) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(4, misses_);
      }
      for (int i = 0; i < missDetails_.size(); i++) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(5, missDetails_.get(i));
      }
      if (loadTimeInMs_ != 0L) {
        size += com.google.protobuf.CodedOutputStream
          .computeUInt64Size(6, loadTimeInMs_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics other = (com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics) obj;

      if (getSizeInBytes()
          != other.getSizeInBytes()) return false;
      if (getSaveTimeInMs()
          != other.getSaveTimeInMs()) return false;
      if (getHits()
          != other.getHits()) return false;
      if (getMisses()
          != other.getMisses()) return false;
      if (!getMissDetailsList()
          .equals(other.getMissDetailsList())) return false;
      if (getLoadTimeInMs()
          != other.getLoadTimeInMs()) return false;
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + SIZE_IN_BYTES_FIELD_NUMBER;
      hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
          getSizeInBytes());
      hash = (37 * hash) + SAVE_TIME_IN_MS_FIELD_NUMBER;
      hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
          getSaveTimeInMs());
      hash = (37 * hash) + HITS_FIELD_NUMBER;
      hash = (53 * hash) + getHits();
      hash = (37 * hash) + MISSES_FIELD_NUMBER;
      hash = (53 * hash) + getMisses();
      if (getMissDetailsCount() > 0) {
        hash = (37 * hash) + MISS_DETAILS_FIELD_NUMBER;
        hash = (53 * hash) + getMissDetailsList().hashCode();
      }
      hash = (37 * hash) + LOAD_TIME_IN_MS_FIELD_NUMBER;
      hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
          getLoadTimeInMs());
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessage
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessage
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessage
          .parseDelimitedWithIOException(PARSER, input);
    }

    public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessage
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessage
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessage
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * Information about the action cache behavior during a single build.
     * </pre>
     *
     * Protobuf type {@code blaze.ActionCacheStatistics}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:blaze.ActionCacheStatistics)
        com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatisticsOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.actions.cache.Protos.internal_static_blaze_ActionCacheStatistics_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.actions.cache.Protos.internal_static_blaze_ActionCacheStatistics_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.class, com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        bitField0_ = 0;
        sizeInBytes_ = 0L;
        saveTimeInMs_ = 0L;
        hits_ = 0;
        misses_ = 0;
        if (missDetailsBuilder_ == null) {
          missDetails_ = java.util.Collections.emptyList();
        } else {
          missDetails_ = null;
          missDetailsBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000010);
        loadTimeInMs_ = 0L;
        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.actions.cache.Protos.internal_static_blaze_ActionCacheStatistics_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics getDefaultInstanceForType() {
        return com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics build() {
        com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics buildPartial() {
        com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics result = new com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics(this);
        buildPartialRepeatedFields(result);
        if (bitField0_ != 0) { buildPartial0(result); }
        onBuilt();
        return result;
      }

      private void buildPartialRepeatedFields(com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics result) {
        if (missDetailsBuilder_ == null) {
          if (((bitField0_ & 0x00000010) != 0)) {
            missDetails_ = java.util.Collections.unmodifiableList(missDetails_);
            bitField0_ = (bitField0_ & ~0x00000010);
          }
          result.missDetails_ = missDetails_;
        } else {
          result.missDetails_ = missDetailsBuilder_.build();
        }
      }

      private void buildPartial0(com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics result) {
        int from_bitField0_ = bitField0_;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          result.sizeInBytes_ = sizeInBytes_;
        }
        if (((from_bitField0_ & 0x00000002) != 0)) {
          result.saveTimeInMs_ = saveTimeInMs_;
        }
        if (((from_bitField0_ & 0x00000004) != 0)) {
          result.hits_ = hits_;
        }
        if (((from_bitField0_ & 0x00000008) != 0)) {
          result.misses_ = misses_;
        }
        if (((from_bitField0_ & 0x00000020) != 0)) {
          result.loadTimeInMs_ = loadTimeInMs_;
        }
      }

      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics) {
          return mergeFrom((com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics other) {
        if (other == com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.getDefaultInstance()) return this;
        if (other.getSizeInBytes() != 0L) {
          setSizeInBytes(other.getSizeInBytes());
        }
        if (other.getSaveTimeInMs() != 0L) {
          setSaveTimeInMs(other.getSaveTimeInMs());
        }
        if (other.getHits() != 0) {
          setHits(other.getHits());
        }
        if (other.getMisses() != 0) {
          setMisses(other.getMisses());
        }
        if (missDetailsBuilder_ == null) {
          if (!other.missDetails_.isEmpty()) {
            if (missDetails_.isEmpty()) {
              missDetails_ = other.missDetails_;
              bitField0_ = (bitField0_ & ~0x00000010);
            } else {
              ensureMissDetailsIsMutable();
              missDetails_.addAll(other.missDetails_);
            }
            onChanged();
          }
        } else {
          if (!other.missDetails_.isEmpty()) {
            if (missDetailsBuilder_.isEmpty()) {
              missDetailsBuilder_.dispose();
              missDetailsBuilder_ = null;
              missDetails_ = other.missDetails_;
              bitField0_ = (bitField0_ & ~0x00000010);
              missDetailsBuilder_ = 
                com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders ?
                   getMissDetailsFieldBuilder() : null;
            } else {
              missDetailsBuilder_.addAllMessages(other.missDetails_);
            }
          }
        }
        if (other.getLoadTimeInMs() != 0L) {
          setLoadTimeInMs(other.getLoadTimeInMs());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 8: {
                sizeInBytes_ = input.readUInt64();
                bitField0_ |= 0x00000001;
                break;
              } // case 8
              case 16: {
                saveTimeInMs_ = input.readUInt64();
                bitField0_ |= 0x00000002;
                break;
              } // case 16
              case 24: {
                hits_ = input.readInt32();
                bitField0_ |= 0x00000004;
                break;
              } // case 24
              case 32: {
                misses_ = input.readInt32();
                bitField0_ |= 0x00000008;
                break;
              } // case 32
              case 42: {
                com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail m =
                    input.readMessage(
                        com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail.parser(),
                        extensionRegistry);
                if (missDetailsBuilder_ == null) {
                  ensureMissDetailsIsMutable();
                  missDetails_.add(m);
                } else {
                  missDetailsBuilder_.addMessage(m);
                }
                break;
              } // case 42
              case 48: {
                loadTimeInMs_ = input.readUInt64();
                bitField0_ |= 0x00000020;
                break;
              } // case 48
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }
      private int bitField0_;

      private long sizeInBytes_ ;
      /**
       * <pre>
       * Size of the action cache in bytes.
       *
       * This is computed by the code that persists the action cache to disk and
       * represents the size of the written files, which has no direct relation to
       * the number of entries in the cache.
       * </pre>
       *
       * <code>uint64 size_in_bytes = 1;</code>
       * @return The sizeInBytes.
       */
      @java.lang.Override
      public long getSizeInBytes() {
        return sizeInBytes_;
      }
      /**
       * <pre>
       * Size of the action cache in bytes.
       *
       * This is computed by the code that persists the action cache to disk and
       * represents the size of the written files, which has no direct relation to
       * the number of entries in the cache.
       * </pre>
       *
       * <code>uint64 size_in_bytes = 1;</code>
       * @param value The sizeInBytes to set.
       * @return This builder for chaining.
       */
      public Builder setSizeInBytes(long value) {

        sizeInBytes_ = value;
        bitField0_ |= 0x00000001;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * Size of the action cache in bytes.
       *
       * This is computed by the code that persists the action cache to disk and
       * represents the size of the written files, which has no direct relation to
       * the number of entries in the cache.
       * </pre>
       *
       * <code>uint64 size_in_bytes = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearSizeInBytes() {
        bitField0_ = (bitField0_ & ~0x00000001);
        sizeInBytes_ = 0L;
        onChanged();
        return this;
      }

      private long saveTimeInMs_ ;
      /**
       * <pre>
       * Time it took to save the action cache to disk.
       * </pre>
       *
       * <code>uint64 save_time_in_ms = 2;</code>
       * @return The saveTimeInMs.
       */
      @java.lang.Override
      public long getSaveTimeInMs() {
        return saveTimeInMs_;
      }
      /**
       * <pre>
       * Time it took to save the action cache to disk.
       * </pre>
       *
       * <code>uint64 save_time_in_ms = 2;</code>
       * @param value The saveTimeInMs to set.
       * @return This builder for chaining.
       */
      public Builder setSaveTimeInMs(long value) {

        saveTimeInMs_ = value;
        bitField0_ |= 0x00000002;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * Time it took to save the action cache to disk.
       * </pre>
       *
       * <code>uint64 save_time_in_ms = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearSaveTimeInMs() {
        bitField0_ = (bitField0_ & ~0x00000002);
        saveTimeInMs_ = 0L;
        onChanged();
        return this;
      }

      private int hits_ ;
      /**
       * <pre>
       * Cache counters.
       * </pre>
       *
       * <code>int32 hits = 3;</code>
       * @return The hits.
       */
      @java.lang.Override
      public int getHits() {
        return hits_;
      }
      /**
       * <pre>
       * Cache counters.
       * </pre>
       *
       * <code>int32 hits = 3;</code>
       * @param value The hits to set.
       * @return This builder for chaining.
       */
      public Builder setHits(int value) {

        hits_ = value;
        bitField0_ |= 0x00000004;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * Cache counters.
       * </pre>
       *
       * <code>int32 hits = 3;</code>
       * @return This builder for chaining.
       */
      public Builder clearHits() {
        bitField0_ = (bitField0_ & ~0x00000004);
        hits_ = 0;
        onChanged();
        return this;
      }

      private int misses_ ;
      /**
       * <code>int32 misses = 4;</code>
       * @return The misses.
       */
      @java.lang.Override
      public int getMisses() {
        return misses_;
      }
      /**
       * <code>int32 misses = 4;</code>
       * @param value The misses to set.
       * @return This builder for chaining.
       */
      public Builder setMisses(int value) {

        misses_ = value;
        bitField0_ |= 0x00000008;
        onChanged();
        return this;
      }
      /**
       * <code>int32 misses = 4;</code>
       * @return This builder for chaining.
       */
      public Builder clearMisses() {
        bitField0_ = (bitField0_ & ~0x00000008);
        misses_ = 0;
        onChanged();
        return this;
      }

      private java.util.List<com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail> missDetails_ =
        java.util.Collections.emptyList();
      private void ensureMissDetailsIsMutable() {
        if (!((bitField0_ & 0x00000010) != 0)) {
          missDetails_ = new java.util.ArrayList<com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail>(missDetails_);
          bitField0_ |= 0x00000010;
         }
      }

      private com.google.protobuf.RepeatedFieldBuilder<
          com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail, com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail.Builder, com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetailOrBuilder> missDetailsBuilder_;

      /**
       * <pre>
       * Breakdown of the cache misses based on the reasons behind them.
       * </pre>
       *
       * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
       */
      public java.util.List<com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail> getMissDetailsList() {
        if (missDetailsBuilder_ == null) {
          return java.util.Collections.unmodifiableList(missDetails_);
        } else {
          return missDetailsBuilder_.getMessageList();
        }
      }
      /**
       * <pre>
       * Breakdown of the cache misses based on the reasons behind them.
       * </pre>
       *
       * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
       */
      public int getMissDetailsCount() {
        if (missDetailsBuilder_ == null) {
          return missDetails_.size();
        } else {
          return missDetailsBuilder_.getCount();
        }
      }
      /**
       * <pre>
       * Breakdown of the cache misses based on the reasons behind them.
       * </pre>
       *
       * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
       */
      public com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail getMissDetails(int index) {
        if (missDetailsBuilder_ == null) {
          return missDetails_.get(index);
        } else {
          return missDetailsBuilder_.getMessage(index);
        }
      }
      /**
       * <pre>
       * Breakdown of the cache misses based on the reasons behind them.
       * </pre>
       *
       * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
       */
      public Builder setMissDetails(
          int index, com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail value) {
        if (missDetailsBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureMissDetailsIsMutable();
          missDetails_.set(index, value);
          onChanged();
        } else {
          missDetailsBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <pre>
       * Breakdown of the cache misses based on the reasons behind them.
       * </pre>
       *
       * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
       */
      public Builder setMissDetails(
          int index, com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail.Builder builderForValue) {
        if (missDetailsBuilder_ == null) {
          ensureMissDetailsIsMutable();
          missDetails_.set(index, builderForValue.build());
          onChanged();
        } else {
          missDetailsBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <pre>
       * Breakdown of the cache misses based on the reasons behind them.
       * </pre>
       *
       * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
       */
      public Builder addMissDetails(com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail value) {
        if (missDetailsBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureMissDetailsIsMutable();
          missDetails_.add(value);
          onChanged();
        } else {
          missDetailsBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <pre>
       * Breakdown of the cache misses based on the reasons behind them.
       * </pre>
       *
       * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
       */
      public Builder addMissDetails(
          int index, com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail value) {
        if (missDetailsBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureMissDetailsIsMutable();
          missDetails_.add(index, value);
          onChanged();
        } else {
          missDetailsBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <pre>
       * Breakdown of the cache misses based on the reasons behind them.
       * </pre>
       *
       * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
       */
      public Builder addMissDetails(
          com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail.Builder builderForValue) {
        if (missDetailsBuilder_ == null) {
          ensureMissDetailsIsMutable();
          missDetails_.add(builderForValue.build());
          onChanged();
        } else {
          missDetailsBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <pre>
       * Breakdown of the cache misses based on the reasons behind them.
       * </pre>
       *
       * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
       */
      public Builder addMissDetails(
          int index, com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail.Builder builderForValue) {
        if (missDetailsBuilder_ == null) {
          ensureMissDetailsIsMutable();
          missDetails_.add(index, builderForValue.build());
          onChanged();
        } else {
          missDetailsBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <pre>
       * Breakdown of the cache misses based on the reasons behind them.
       * </pre>
       *
       * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
       */
      public Builder addAllMissDetails(
          java.lang.Iterable<? extends com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail> values) {
        if (missDetailsBuilder_ == null) {
          ensureMissDetailsIsMutable();
          com.google.protobuf.AbstractMessageLite.Builder.addAll(
              values, missDetails_);
          onChanged();
        } else {
          missDetailsBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <pre>
       * Breakdown of the cache misses based on the reasons behind them.
       * </pre>
       *
       * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
       */
      public Builder clearMissDetails() {
        if (missDetailsBuilder_ == null) {
          missDetails_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000010);
          onChanged();
        } else {
          missDetailsBuilder_.clear();
        }
        return this;
      }
      /**
       * <pre>
       * Breakdown of the cache misses based on the reasons behind them.
       * </pre>
       *
       * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
       */
      public Builder removeMissDetails(int index) {
        if (missDetailsBuilder_ == null) {
          ensureMissDetailsIsMutable();
          missDetails_.remove(index);
          onChanged();
        } else {
          missDetailsBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <pre>
       * Breakdown of the cache misses based on the reasons behind them.
       * </pre>
       *
       * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
       */
      public com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail.Builder getMissDetailsBuilder(
          int index) {
        return getMissDetailsFieldBuilder().getBuilder(index);
      }
      /**
       * <pre>
       * Breakdown of the cache misses based on the reasons behind them.
       * </pre>
       *
       * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
       */
      public com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetailOrBuilder getMissDetailsOrBuilder(
          int index) {
        if (missDetailsBuilder_ == null) {
          return missDetails_.get(index);  } else {
          return missDetailsBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <pre>
       * Breakdown of the cache misses based on the reasons behind them.
       * </pre>
       *
       * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
       */
      public java.util.List<? extends com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetailOrBuilder> 
           getMissDetailsOrBuilderList() {
        if (missDetailsBuilder_ != null) {
          return missDetailsBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(missDetails_);
        }
      }
      /**
       * <pre>
       * Breakdown of the cache misses based on the reasons behind them.
       * </pre>
       *
       * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
       */
      public com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail.Builder addMissDetailsBuilder() {
        return getMissDetailsFieldBuilder().addBuilder(
            com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail.getDefaultInstance());
      }
      /**
       * <pre>
       * Breakdown of the cache misses based on the reasons behind them.
       * </pre>
       *
       * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
       */
      public com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail.Builder addMissDetailsBuilder(
          int index) {
        return getMissDetailsFieldBuilder().addBuilder(
            index, com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail.getDefaultInstance());
      }
      /**
       * <pre>
       * Breakdown of the cache misses based on the reasons behind them.
       * </pre>
       *
       * <code>repeated .blaze.ActionCacheStatistics.MissDetail miss_details = 5;</code>
       */
      public java.util.List<com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail.Builder> 
           getMissDetailsBuilderList() {
        return getMissDetailsFieldBuilder().getBuilderList();
      }
      private com.google.protobuf.RepeatedFieldBuilder<
          com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail, com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail.Builder, com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetailOrBuilder> 
          getMissDetailsFieldBuilder() {
        if (missDetailsBuilder_ == null) {
          missDetailsBuilder_ = new com.google.protobuf.RepeatedFieldBuilder<
              com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail, com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetail.Builder, com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics.MissDetailOrBuilder>(
                  missDetails_,
                  ((bitField0_ & 0x00000010) != 0),
                  getParentForChildren(),
                  isClean());
          missDetails_ = null;
        }
        return missDetailsBuilder_;
      }

      private long loadTimeInMs_ ;
      /**
       * <pre>
       * Time it took to load the action cache from disk. Reported as 0 if the
       * action cache has not been loaded in this invocation.
       * </pre>
       *
       * <code>uint64 load_time_in_ms = 6;</code>
       * @return The loadTimeInMs.
       */
      @java.lang.Override
      public long getLoadTimeInMs() {
        return loadTimeInMs_;
      }
      /**
       * <pre>
       * Time it took to load the action cache from disk. Reported as 0 if the
       * action cache has not been loaded in this invocation.
       * </pre>
       *
       * <code>uint64 load_time_in_ms = 6;</code>
       * @param value The loadTimeInMs to set.
       * @return This builder for chaining.
       */
      public Builder setLoadTimeInMs(long value) {

        loadTimeInMs_ = value;
        bitField0_ |= 0x00000020;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * Time it took to load the action cache from disk. Reported as 0 if the
       * action cache has not been loaded in this invocation.
       * </pre>
       *
       * <code>uint64 load_time_in_ms = 6;</code>
       * @return This builder for chaining.
       */
      public Builder clearLoadTimeInMs() {
        bitField0_ = (bitField0_ & ~0x00000020);
        loadTimeInMs_ = 0L;
        onChanged();
        return this;
      }

      // @@protoc_insertion_point(builder_scope:blaze.ActionCacheStatistics)
    }

    // @@protoc_insertion_point(class_scope:blaze.ActionCacheStatistics)
    private static final com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics();
    }

    public static com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<ActionCacheStatistics>
        PARSER = new com.google.protobuf.AbstractParser<ActionCacheStatistics>() {
      @java.lang.Override
      public ActionCacheStatistics parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<ActionCacheStatistics> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<ActionCacheStatistics> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.actions.cache.Protos.ActionCacheStatistics getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_blaze_ActionCacheStatistics_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_blaze_ActionCacheStatistics_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_blaze_ActionCacheStatistics_MissDetail_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_blaze_ActionCacheStatistics_MissDetail_fieldAccessorTable;

  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static  com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n$src/main/protobuf/action_cache.proto\022\005" +
      "blaze\"\335\003\n\025ActionCacheStatistics\022\025\n\rsize_" +
      "in_bytes\030\001 \001(\004\022\027\n\017save_time_in_ms\030\002 \001(\004\022" +
      "\014\n\004hits\030\003 \001(\005\022\016\n\006misses\030\004 \001(\005\022=\n\014miss_de" +
      "tails\030\005 \003(\0132\'.blaze.ActionCacheStatistic" +
      "s.MissDetail\022\027\n\017load_time_in_ms\030\006 \001(\004\032T\n" +
      "\nMissDetail\0227\n\006reason\030\001 \001(\0162\'.blaze.Acti" +
      "onCacheStatistics.MissReason\022\r\n\005count\030\002 " +
      "\001(\005\"\307\001\n\nMissReason\022\030\n\024DIFFERENT_ACTION_K" +
      "EY\020\000\022\022\n\016DIFFERENT_DEPS\020\001\022\031\n\025DIFFERENT_EN" +
      "VIRONMENT\020\002\022\023\n\017DIFFERENT_FILES\020\003\022\031\n\025CORR" +
      "UPTED_CACHE_ENTRY\020\004\022\016\n\nNOT_CACHED\020\005\022\033\n\027U" +
      "NCONDITIONAL_EXECUTION\020\006\022\023\n\017DIGEST_MISMA" +
      "TCH\020\007B5\n+com.google.devtools.build.lib.a" +
      "ctions.cacheB\006Protosb\006proto3"
    };
    descriptor = com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        });
    internal_static_blaze_ActionCacheStatistics_descriptor =
      getDescriptor().getMessageTypes().get(0);
    internal_static_blaze_ActionCacheStatistics_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessage.FieldAccessorTable(
        internal_static_blaze_ActionCacheStatistics_descriptor,
        new java.lang.String[] { "SizeInBytes", "SaveTimeInMs", "Hits", "Misses", "MissDetails", "LoadTimeInMs", });
    internal_static_blaze_ActionCacheStatistics_MissDetail_descriptor =
      internal_static_blaze_ActionCacheStatistics_descriptor.getNestedTypes().get(0);
    internal_static_blaze_ActionCacheStatistics_MissDetail_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessage.FieldAccessorTable(
        internal_static_blaze_ActionCacheStatistics_MissDetail_descriptor,
        new java.lang.String[] { "Reason", "Count", });
    descriptor.resolveAllFeaturesImmutable();
  }

  // @@protoc_insertion_point(outer_class_scope)
}
